package test.weld.gradle;

import java.util.Set;

import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.Bean;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.InjectionPoint;
import javax.inject.Named;

/**
 * Created by starksm on 9/27/15.
 */
public class MyProducerMethods {
    @Produces
    @Produced
    public static <E extends Enum> IFactory<E> getMachineFactory(InjectionPoint ip, BeanManager beanManager) {
        Set<Bean<?>> beans = beanManager.getBeans(IFactory.class);
        System.out.printf("Found %d beans of type IFactory\n", beans.size());
        Bean<IFactory> factoryBean = null;
        for (Bean bean : beans) {
            factoryBean = bean;
            break;
        }

        if(factoryBean != null) {
            System.out.printf("Found bean of type IFactory: %s\n", factoryBean);
            CreationalContext<IFactory> ctx = beanManager.createCreationalContext(factoryBean);
            IFactory factory = factoryBean.create(ctx);
            return factory;
        } else {
            System.err.printf("Failed to find bean of type IFactory\n");
        }
        return null;
    }
}
